renoise.tool():add_keybinding {
  name = "Global:Tools:Search For Inactive Devices",
  invoke = function()search()end
  
}

--[[-----------------------
--Tool menu entry
-----------------------
renoise.tool():add_menu_entry {
  name = "Main Menu:Tools:Ledger`s Scripts:Search For Inactive Devices",
  invoke = function()search()end
  
}
--]]

--returns the pattern command text for device number
----------------------------------------------------------
local function get_devices_patternfx_num_or_letter(device_index)
----------------------------------------------------------
  
  if device_index < 10 then
    return tostring(device_index)
  elseif device_index == 10 then
    return "A"
  elseif device_index == 11 then
    return "B"
  elseif device_index == 12 then
    return "C"
  elseif device_index == 13 then
    return "D"
  elseif device_index == 14 then
    return "E"
  elseif device_index == 15 then
    return "F"
  elseif device_index == 16 then
    return "G"
  elseif device_index == 17 then
    return "H"
  elseif device_index == 18 then
    return "I"
  elseif device_index == 19 then
    return "J"
  elseif device_index == 20 then
    return "K"
  elseif device_index == 21 then
    return "L"
  elseif device_index == 22 then
    return "M"
  elseif device_index == 23 then
    return "N"
  elseif device_index == 24 then
    return "O"
  elseif device_index == 25 then
    return "P"
  elseif device_index == 26 then
    return "Q"
  elseif device_index == 27 then
    return "R"
  elseif device_index == 28 then
    return "S"
  elseif device_index == 29 then
    return "T"
  elseif device_index == 30 then
    return "U"
  elseif device_index == 31 then
    return "V"
  elseif device_index == 32 then
    return "W"
  elseif device_index == 33 then
    return "X"
  elseif device_index == 34 then
    return "Y"
  end
  --renoise pattern commands 'only' go to 34 devices
  return nil
end

--currently searches hidden patterns also
----------------------------------------------------------
local function find_any_enable_commands_for_device_in_track(track_index,device_index)
----------------------------------------------------------
 
  local song = renoise.song()
  local sel_dev_idx = (device_index - 1)-- or song.selected_device_index - 1
  
  if sel_dev_idx == 0 then
    status("No Bypassable Device Chosen In Renoise")
    return
  end
   
  --get hex format of device_index
  local dev_idx_str = get_devices_patternfx_num_or_letter(sel_dev_idx)

  if dev_idx_str == nil then
    error("Not A Valid Device Index")
   return
  end

  local trk_idx = track_index-- or song.selected_track_index
 --local pat_seq = song.sequencer.pattern_sequence
  local max_cols = renoise.InstrumentPhrase.MAX_NUMBER_OF_EFFECT_COLUMNS
 --local seq_idx = song.selected_sequence_index
 
  
  --loop all patterns available in sequencer (we don't need hidden/ unused patterns)
  for pat_idx = 1 ,#song.patterns do
    -- print(pat_idx)
    local cur_pat_trk = song:pattern(pat_idx):track(trk_idx)
    if cur_pat_trk.is_empty == false then
      --loop lines in pattern
      for lines = 1, #cur_pat_trk.lines do
        local cur_line = cur_pat_trk:line(lines)
        if cur_line.is_empty == false then
          --loop columns in line
          for fx_cols = 1,max_cols do
            --if tracks[].lines[].effect_columns[].is_empty
            local cur_col = cur_line:effect_column(fx_cols)
            if cur_col.is_empty == false then
              local num_string = cur_col.number_string
              local fx_string = cur_col.amount_string
              local first_num_str = string.sub(num_string,1,1)
              local second_num_str = string.sub(num_string,2,2)
              --check for bypass command for specified device_index
              if (first_num_str == dev_idx_str) and (second_num_str == "0") then --bypass command == 'X000' or 'X001'
                if fx_string == "01" then
                  return true
                end
              end 
            end 
          end
        end
      end
    end--pat empty  
  end 
  
  return false  
end

-----------------------------------------
local function display_unused_devices_in_song()
-----------------------------------------

  --table to hold any device objects that are unused
  local song = renoise.song()
  local devices = {}
  local counter = 0
  local switched_on = false
  --1) check all pattern_track fx cols
  -------------------------------------
  --loop all tracks
  for trk_idx = 1,#song.tracks do
   
    --loop all devices
    for dev_idx = 2,#song:track(trk_idx).devices do
      switched_on = false
      local cur_dev = song:track(trk_idx):device(dev_idx)
      if cur_dev.is_active == false then
        --first check if any switch on commands in fx cols of track
        if (find_any_enable_commands_for_device_in_track(trk_idx,dev_idx) == false) then
          --none found so check the automation lanes
          --loop the 'is_active' parameter in automations (per pattern)
          ----------------------------
          local function check_autos()
          ----------------------------
            for pat = 1,#song.patterns do
              local automations = song:pattern(pat):track(trk_idx).automation
              for auto = 1,#automations do
                --see if parameter present in current pattern
                if rawequal(automations[auto].dest_parameter,cur_dev.is_active_parameter) then
  
                  for point = 1, #automations[auto].points do
                    --if 1 then we found an on command
                    if automations[auto].points[point].value == 1 then
                      switched_on = true
                      return
                    end
                  end
                end
              end
            end
          end
          check_autos()
          --no switched on commands anywhere so add to table
          if switched_on == false then
            --no enable commands found in pattern so add this device to table
            counter = counter + 1
            devices[counter] = {}
           -- devices[counter].device = song:track(trk_idx):device(dev_idx)
            devices[counter].index = dev_idx
            devices[counter].name = song:track(trk_idx):device(dev_idx).short_name
            devices[counter].track_name = song:track(trk_idx).name
            devices[counter].track_index = trk_idx
          end --switched on
        end--if find enable
      end--if cur device active
    end--for devs
  end--for tracks
  
  local return_string = ""
 
  --if devices[1] ~= nil set it to devices[1].track_index 
  local trk_idx = devices[1] and devices[1].track_index 

  
  for i = 1,#devices do
    if trk_idx ~= devices[i].track_index then
      return_string = return_string.."\n"
      trk_idx = devices[i].track_index
    end
    return_string = return_string..devices[i].track_name.."  -  Device "..tostring(devices[i].index -1)..":   " ..devices[i].name.."     ".."\n"
 
  end
  
  if return_string == "" then
    return "\nAll Devices Are Used"
  else
    return "\n     Inactive Devices, Never Switched On In The Song:\n\n"..return_string
  end
end 


--global variables for gui
local my_dialog2 = nil 
local vb2 = nil

-----------------
function search()
-----------------
  

  --toggle dialog so if its already open then close it.  The timer will catch
  --that it is closed and do the housekeeping like removing notifiers (and timer itself)
  if (my_dialog2 and my_dialog2.visible) then 
    my_dialog2:close()
    return
  end
  
  my_dialog2 = nil 
  vb2 = nil
  
  --renoise song object
  local song = renoise.song()
  
  --set globals
  -------------
  --assign global vb2 to viewbuilder
  vb2 = renoise.ViewBuilder()
  
  ----------------------------------------------
  --GUI
  ----------------------------------------------     

  --variables that will be added to
  --dialog_content:add_child(send_row)
  local my_first_row = vb2:column{}
  -------------------------------
  local my_first_element = nil
  

    my_first_element = vb2:column{
                        margin = 2,
                          vb2:button{
                           text = "Re-Check",
                           notifier = function()
                                        --update readout string
                                        vb2.views["readout string"].text = display_unused_devices_in_song()
                                        --
                                        status("List Updated")
                                        
                                      end
                          },

                        vb2:multiline_textfield { 
                         id = "readout string",
                         width = 310,
                         height = 200,
                         text = display_unused_devices_in_song()
                        }
                       }


    my_first_row:add_child(my_first_element) 
  

  
  --------------------------------------------------------
  --------------------------------------------------------
  --dialog content will contain all of gui; passed to renoise.app():show_custom_dialog()
  local dialog_content = vb2:column{}
  dialog_content:add_child(my_first_row)
 
  --------------
  --key Handler
  --------------
  local function my_keyhandler_func(dialog,key)
     --toggle lock focus hack, allows pattern ed to get key input
     renoise.app().window.lock_keyboard_focus = not renoise.app().window.lock_keyboard_focus
     renoise.app().window.lock_keyboard_focus = not renoise.app().window.lock_keyboard_focus
     return key
  end 
  
 
  ------------------------------------------------------------------------------------------
  ------------------------------------------------------------------------------------------
  --Script dialog
  my_dialog2 = renoise.app():show_custom_dialog(
      "Unused Devices In Song", dialog_content,my_keyhandler_func)

 --[[ 
  --add timer to fire once every 50ms
  if not renoise.tool():has_timer(timer) then
    renoise.tool():add_timer(timer,80)
  end
  --]]
  
  --------------------------------------------    
  --close dialog function ON NEW SONG
  --------------------------------------------
  local function closer(d)
    --close dialog if exists and is open     
    if (d ~= nil) and (d.visible == true) then
      d:close()
     -- remove_notifiers()
    end
    --reset global my_dialog2
     my_dialog2 = nil 
  end
  -- notifier to close dialog on load new song
  renoise.tool().app_release_document_observable:add_notifier(closer,my_dialog2)
  -------------------------------------------------------------------------------
  
  --first run of timer
  -- timer()

  --renoise.app():show_message(display_unused_devices_in_song())
end




